/// <reference types="react" />
import * as React from 'react';
import Query from 'bicycle/types/Query';
import { BaseRootQuery } from 'bicycle/typed-helpers/query';
import ErrorResult from 'bicycle/types/ErrorResult';
import Component from '../component-class';
export declare type GetQuery<Props, QueryResult> = (props: Props) => BaseRootQuery<QueryResult> | Query;
export declare type GetEventHandlers<Props, EventHandlers> = (client: any, props: Props) => EventHandlers;
export interface Options<Props> {
    renderLoading?: boolean | Component<Props>;
    renderErrors?: boolean | Component<Props>;
}
export interface ConnectResultProps<QueryResult> {
    result: QueryResult;
    loaded: boolean;
    errors: ReadonlyArray<string>;
    errorDetails: ReadonlyArray<ErrorResult>;
    isLoaded(path: string): boolean;
    isLoaded(value: any, path: string): boolean;
    WrappedComponent: any;
    previousElement: React.ReactNode;
}
export declare type ConnectProps<QueryResult, EventHandlers = {}> = ConnectResultProps<QueryResult> & EventHandlers;
export default function <OriginalProps extends {}, QueryResult, InjectedEventHandlers>(WrappedComponent: Component<OriginalProps & InjectedEventHandlers & ConnectResultProps<QueryResult>>, getQuery?: GetQuery<OriginalProps, QueryResult>, getEventHandlers?: GetEventHandlers<OriginalProps, InjectedEventHandlers>, options?: Options<OriginalProps & InjectedEventHandlers & ConnectResultProps<QueryResult>>): React.ComponentClass<OriginalProps>;
